## fpc 3.0.4+dfsg

=== fpcdocs/datutex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=fpc
endif
else
override FPC=fpc
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif
ifdef inUnix
EXECPREFIX=./
else
EXECPREFIX=
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean execute

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex9 ex10 ex11 ex12\
        ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 ex21 ex22 ex23 ex24\
        ex25 ex26 ex27 ex28 ex29 ex30 ex31 ex32 ex33 ex34 ex35 ex36\
        ex37 ex38 ex39 ex40 ex41 ex42 ex43 ex44 ex45 ex46 ex47\
        ex48 ex49 ex50 ex51 ex52 ex53 ex54 ex55 ex56 ex57 ex58\
        ex59 ex60 ex61 ex62 ex63 ex64 ex65 ex66 ex67 ex68 ex69 ex70\
        ex71 ex72 ex73 ex74 ex75 ex76 ex77 ex78 ex79 ex80 \
        ex81 ex82 ex83 ex84 ex85 ex86 ex87 ex88 ex89 ex90 ex91 ex92 \
        ex93 ex94 ex95 ex96 ex97 ex98 ex99 ex100 ex101 ex102 ex103\
        ex104 ex105 ex106

# This might not be the same list as objects, since some of the
# tests might be interactive.
TOTEST=$(OBJECTS)

LOGFILES=$(addsuffix .log, $(TOTEST))


TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

EXEOBJECTS=$(addsuffix $(EXEEXT), $(OBJECTS))

all : $(EXEOBJECTS)

execute: $(LOGFILES)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean :
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll *.ppw *.tmp *.log *.dat

$(EXEOBJECTS): %$(EXEEXT): %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

$(LOGFILES): %.log: %$(EXEEXT)
	$(EXECPREFIX)$*$(EXEEXT) > $*.log

=== fpcdocs/heapex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)


# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean

OBJECTS=heapex setinfo

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

=== fpcdocs/objectex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler
ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)
# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif
ifdef inUnix
EXECPREFIX=./
else
EXECPREFIX=
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean execute

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 \
        ex11 ex12 ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 \
        ex21 ex22 ex23 ex24 ex25 ex26 ex27 ex28 ex29 ex30 \
        ex31 ex32 ex33 ex34 ex35 ex36 ex37 ex38 ex39 ex40

# This might not be the same list as objects, since some of the
# tests might be interactive.
TOTEST=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 \
        ex11 ex12 ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 \
        ex21 ex22 ex23 ex24 ex25 ex26 ex27 ex28 ex29 ex30 \
        ex31 ex32 ex33 ex34 ex35 ex37 ex38 ex39 ex40

LOGFILES=$(addsuffix .log, $(TOTEST))


TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

EXEOBJECTS=$(addsuffix $(EXEEXT), $(OBJECTS))

all : $(EXEOBJECTS)

tex : $(TEXOBJECTS) myobject.tex mysortc.tex

execute: $(LOGFILES)


onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS) mysortc.ppu myobject.ppu mysortc.tex myobject.tex test.dat
	-rm -f *.ow *.sw *.exe *.dll *.ppw *.log *.tmp 
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS) myobject.tex mysortc.tex: %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

$(LOGFILES): %.log: %$(EXEEXT)
	$(EXECPREFIX)$*$(EXEEXT) > $*.log

=== fpcdocs/refex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler
ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits

# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif
ifdef inUnix
EXECPREFIX=./
else
EXECPREFIX=
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean execute

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 ex11 ex12 ex13 ex14 \
        ex15 ex16 ex17 ex18 ex19 ex20 ex21 ex22 ex23 ex24 ex25 ex26 ex27 \
        ex28 ex29 ex30 ex31 ex32 ex33 ex34 ex35 ex36 ex37 ex38 ex39 ex40 \
        ex41 ex42 ex43 ex44 ex45 ex46 ex47 ex48 ex49 ex50 ex51 ex52 ex53 \
        ex54 ex55 ex56 ex57 ex58 ex59 ex60 ex61 ex62 ex63 ex64 ex65 ex66 \
        ex67 ex68 ex69 ex70 ex71 ex72 ex73 ex74 ex75 ex76 ex77 ex78 ex79 \
	ex80 ex81 ex82 ex83 ex84 ex85 ex86 ex87 ex88 ex89 \
	ex90 ex91 ex92 ex93 ex94 ex95 ex96 ex97 ex98 ex99 ex100 ex101 ex102\
        ex103 ex104 ex105 ex106 ex107 ex108 ex109 ex110 ex111 ex112

EXEOBJECTS=$(addsuffix $(EXEEXT), $(OBJECTS))

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

# This is not the same list as objects, since some of the
# tests are interactive.
TOTEST=ex1 ex2 ex3 ex4 ex5 ex8 ex9 ex10 ex11 ex12 ex13 ex14 \
        ex15 ex16 ex17 ex20 ex21 ex22 ex23 ex25 ex26 ex27 \
        ex28 ex29 ex31 ex32 ex33 ex34 ex36 ex37 ex38 ex39 ex40 \
        ex41 ex42 ex43 ex44 ex45 ex47 ex48 ex52 ex53 \
        ex54 ex56 ex59 ex60 ex62 ex63 ex64 ex65 ex66 \
        ex67 ex68 ex69 ex70 ex71 ex72 ex73 ex75 ex76 ex78 ex79 \
	ex80 ex81 ex82 ex83 ex85 ex86 ex87 ex88 ex89 \
	ex90 ex91 ex92 ex93 ex96 ex97 ex98 ex99 ex100 ex101 ex102\
        ex103 ex104 ex105 ex106 ex107 ex108 ex109 ex110 ex111 ex112


LOGFILES=$(addsuffix .log, $(TOTEST))


all : $(OBJECTS)

tex : $(TEXOBJECTS)

execute: $(LOGFILES)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s *.rst $(OBJECTS)
	-rm -f $(TEXOBJECTS)
	-rm -f *.exe *.dll *.so *.rsj *.log *.tmp
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

$(LOGFILES): %.log: %$(EXEEXT)
	$(EXECPREFIX)$*$(EXEEXT) > $*.log

=== install/man/Makefile ===
##################################
# Man page installation for unix
#

override PATH:=$(subst \,/,$(PATH))
SEARCHPATH:=$(filter-out .,$(subst :, ,$(PATH)))


ifndef INSTALL_PREFIX
INSTALL_PREFIX=/usr/local
endif

ifndef GINSTALL
GINSTALL:=$(strip $(wildcard $(addsuffix /ginstall,$(SEARCHPATH))))
ifeq ($(GINSTALL),)
GINSTALL:=$(strip $(wildcard $(addsuffix /install,$(SEARCHPATH))))
ifeq ($(GINSTALL),)
GINSTALL=
else
GINSTALL:=$(firstword $(GINSTALL))
endif
else
GINSTALL:=$(firstword $(GINSTALL))
endif
endif

INSTALL_MANDIR=$(INSTALL_PREFIX)/man

installman:
	$(GINSTALL) -d -m 755 $(INSTALL_MANDIR)/man1
	$(GINSTALL) -d -m 755 $(INSTALL_MANDIR)/man5
	$(GINSTALL) -c -m 644 man1/*.1 $(INSTALL_MANDIR)/man1
	$(GINSTALL) -c -m 644 man5/*.5 $(INSTALL_MANDIR)/man5
	find man1/*.1 -exec gzip -9f $(INSTALL_MANDIR)/'{}' \;
	find man5/*.5 -exec gzip -9f $(INSTALL_MANDIR)/'{}' \;

=== fpcsrc/utils/fpdoc/intl/Makefile ===
all:	de

clean:
	@rm -f *.mo *.pot

de:
	msgfmt fpdoc.de.po dwriter.de.po -o fpdoc.de.mo
	msgfmt dglobals.de.po -o dglobals.de.mo
	msgfmt makeskel.de.po -o makeskel.de.mo
	msgfmt fpdocmk.de.po -o fpdocmk.de.mo

pot:
	rstconv -i ../dglobals.rst -o dglobals.pot
	rstconv -i ../dwriter.rst -o dwriter.pot
	rstconv -i ../fpdoc.rst -o fpdoc.pot
	rstconv -i ../makeskel.rst -o makeskel.pot
	rstconv -i ../fpdocmk.rst -o fpdocmk.pot

install:
	install -D -m 0644 fpdoc.de.mo /usr/local/share/locale/de/LC_MESSAGES/fpdoc.mo
	install -D -m 0644 dglobals.de.mo /usr/local/share/locale/de/LC_MESSAGES/dglobals.mo
	install -D -m 0644 makeskel.de.mo /usr/local/share/locale/de/LC_MESSAGES/makeskel.mo
	install -D -m 0644 fpdocmk.de.mo /usr/local/share/locale/de/LC_MESSAGES/fpdocmk.mo

=== debian/changelog ===
fpc (3.0.4+dfsg-22mx17+1) mx; urgency=medium

  * Repackaged for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Tue, 05 Mar 2019 08:17:35 -0800

fpc (3.0.4+dfsg-22~bpo9+2) stretch-backports; urgency=medium

  * Rebuild with backport specific patch applied

 -- Paul Gevers <elbrus@debian.org>  Fri, 22 Feb 2019 18:33:09 +0100

fpc (3.0.4+dfsg-22~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Paul Gevers <elbrus@debian.org>  Fri, 22 Feb 2019 11:31:29 +0100

fpc (3.0.4+dfsg-22) unstable; urgency=medium

  * debian/patches/arm64-select.patch
    - Fix fpSelect with nil timestamp on aarch64 (closes: 888782)
  * debian/patches/arm64-subsetreg-32.patch
    - when optimising subsetreg moves for aarch64, take into account the fact
      that the subsetreg itself can be 32 or 64 bit
    - fixes "Incorrect record member value when returned from a function". 
      (closes: 895693)

 -- Peter Michael Green <plugwash@debian.org>  Thu, 24 Jan 2019 23:27:02 +0000

fpc (3.0.4+dfsg-21) unstable; urgency=medium

  [ Paul Gevers ]
  * Drop Recommends: libggi2-dev as it was removed from Debian in 2012.
    We should probably remove ggigraphs unit as well as it is useless
  * Drop ancient Breaks/Replaces, add one missing

  [ Abou Al Montacir ]
  * Moved compiler messages files to location expected by Lazarus.
    The files are anyway architecture independent and it does not hurt
    to have them in /usr/share. (Closes: Bug##902888)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Wed, 16 Jan 2019 10:14:10 +0100

fpc (3.0.4+dfsg-20~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Unapply ncurses6.patch and invert libncursesw5-dev Breaks in
    fp-units-misc-3.0.4

 -- Paul Gevers <elbrus@debian.org>  Fri, 13 Jul 2018 21:14:19 +0200

fpc (3.0.4+dfsg-20) unstable; urgency=medium

  * debian/patches/fpc-r38400.patch:
    - fix crash when hedgewars closes (LP: #1779648).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 Jul 2018 14:08:20 +0200

fpc (3.0.4+dfsg-19) unstable; urgency=medium

  [Graham Inggs]
  * Fixed ppc suffix in fpcmake to be compatible with ppc executable name
    On Motorola 68000, FPC builds compiler named ppc68k while
    fpcmake looks for ppcm68k to set default FPCDIR value
    See #892285

  [Peter Michael Green]
  * Move Grahams fpcmake m68k change into it's own patch fpcmake-m68k.patch
  * Apply Sven Joachim's patch for ncurses6 (Closes: 898017)
  * Add breaks libncursesw5-dev (<< 6.1+20180210) to fp-units-base
  * Add note to debian/control about ncurses adjustments needed when
    backporting.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 12 May 2018 01:36:01 +0100

fpc (3.0.4+dfsg-18) unstable; urgency=medium

  * Remove dpkg-architecture calls to reduce build time and lintian warnings
  * Changed Vcs-Git and Vcs-Browser to point to salsa.debian.org.
    This removes lintian warnings about old repository links.
  * Cleaned man page for fpcjres tool to be lintian warnings free.
  * Fixed ppc suffix in fpcmake to be compatible with ppc executable name.
    For arm64 architecture, FPC make files build compiler as ppca64 while
    fpcmake looks for ppcxaarch64 to set default FPCDIR value.
    Thanks to Graham Inggs (Closes: Bug#892285)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 22 Apr 2018 16:10:23 +0200

fpc (3.0.4+dfsg-17) unstable; urgency=medium

  * Fixed ppc suffix in fpcmake to be compatible with ppc executable name.
    For x86_64 architecture, FPC make files build compiler as ppcx64 while
    fpcmake looks for ppcx86_64 to set default FPCDIR value.
  * Patched fpcmake to look for FPCDIR in Debian FPC sources location.
    (Closes: Bug#892285)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 14 Apr 2018 18:08:39 +0200

fpc (3.0.4+dfsg-16) unstable; urgency=medium

  * [tests] Update autopkgtest reference files

 -- Paul Gevers <elbrus@debian.org>  Fri, 02 Mar 2018 09:13:21 +0100

fpc (3.0.4+dfsg-15) unstable; urgency=medium

  * Fixed FpMkUnit for ARM based architectures. (Closes: Bug#888697)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 03 Feb 2018 10:30:21 +0100

fpc (3.0.4+dfsg-14) unstable; urgency=medium

  * Fixed fpmkunit to use new MA compatible unit paths.
    Thanks to Michalis Kamburelis for the hints.
    (Closes: Bug#636088, Bug#887967, Bug#887575)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 22 Jan 2018 10:28:53 +0100

fpc (3.0.4+dfsg-13) unstable; urgency=medium

  * Fixed typo in change log file.
  * Bumped standard version to 4.1.3. Use https in URLS.
  * Fixed fp-utils_${VERSION} package dependencies to fix upgrade issues.
    (Closes: Bug#886859)
  * Fixed alternatives removal for package fp-compiler_${VERSION}.
    (Closes: Bug#886926)
  * Added missing man file of fp-fix-timestamp in package fp-utils.
    Removes a lintian warning.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 12 Jan 2018 09:54:33 +0100

fpc (3.0.4+dfsg-12) unstable; urgency=medium

  * Changed fp-ide and fp-utils packages to be arch:all as suggested by
    Multiarch hinter tool.
  * Fixed man pages after executables renaming required by MA changes.
  * Fix IDE GDB support by importing MI supoort from upstream trunk.
    (Closes: Bug#528855)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 07 Jan 2018 13:37:01 +0100

fpc (3.0.4+dfsg-11) unstable; urgency=medium

  * Fixed upgrade of fp-utils from older version. (Closes: #885102)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 30 Dec 2017 21:14:32 +0100

fpc (3.0.4+dfsg-10) unstable; urgency=medium

  * Fixed upgrade of fp-utils from older version. (Closes: #885102)
  * Fixed upstream test suite by generating missing configuration file.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 25 Dec 2017 20:30:59 +0100

fpc (3.0.4+dfsg-9) unstable; urgency=medium

  * Renamed binaries of fp-compiler to <triplet>-* as it is forbidden by
    policy to have sub-directories in /us/bin.


=== debian/control ===
Source: fpc
Section: devel
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>,
 Peter Michael Green <plugwash@debian.org>,
Standards-Version: 4.1.3
Build-Depends:
 binutils,
 debhelper (>= 10~),
 dh-exec (>=0.22),
 fp-compiler,
 fp-units-base,
 fp-units-fcl,
 fp-utils,
 ghostscript,
 libncurses-dev,
 mawk | awk,
 po-debconf,
 txt2man,
Build-Depends-Indep:
 hevea,
 rdfind,
 symlinks
Vcs-Git: https://salsa.debian.org/pascal-team/fpc
Vcs-Browser: https://salsa.debian.org/pascal-team/fpc
Homepage: https://www.freepascal.org/

Package: fpc-3.0.4
Architecture: all
Depends:
 fp-compiler-3.0.4 (>= ${binary:Version}),
 fp-ide-3.0.4 (>= ${binary:Version}),
 fp-units-base-3.0.4 (>= ${binary:Version}),
 fp-units-db-3.0.4 (>= ${binary:Version}),
 fp-units-fcl-3.0.4 (>= ${binary:Version}),
 fp-units-fv-3.0.4 (>= ${binary:Version}),
 fp-units-gfx-3.0.4 (>= ${binary:Version}),
 fp-units-gtk2-3.0.4 (>= ${binary:Version}),
 fp-units-math-3.0.4 (>= ${binary:Version}),
 fp-units-misc-3.0.4 (>= ${binary:Version}),
 fp-units-multimedia-3.0.4 (>= ${binary:Version}),
 fp-units-net-3.0.4 (>= ${binary:Version}),
 fp-units-rtl-3.0.4 (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.4
Suggests:
 fp-docs-3.0.4 (>= ${source:Upstream-Version}),
 lazarus
Provides:
 fpc
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - SDK-3.0.4 suite
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This metapackage pulls in all the FPC packages provided for this
 architecture. Experienced users may instead prefer to install the particular
 packages they require by hand.

Package: fpc-source-3.0.4
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fpc-source
Breaks:
 fpc-src
Replaces:
 fpc-src
Description: Free Pascal - SDK source code
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains Free Pascal's own source code. It is meant to be used by
 the Lazarus IDE.

Package: fp-compiler-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 binutils,
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.4 (>= ${binary:Version})
Suggests:
 fp-docs-3.0.4 (>= ${source:Upstream-Version}),
Provides:
 fp-compiler
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - compiler
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This package contains the command line compiler.

Package: fp-ide-3.0.4
Architecture: any
Multi-Arch: foreign
Depends:
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.4 (>= ${binary:Version})
Suggests:
 fp-docs-3.0.4 (>= ${source:Upstream-Version})
Provides:
 fp-ide
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - IDE
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This package contains the Integrated Development Environment (IDE). The IDE
 has an internal compiler.

Package: fp-utils-3.0.4
Architecture: any
Multi-Arch: foreign
Depends:
 fpc-source-3.0.4,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-compiler-3.0.4 (= ${binary:Version})
Provides:
 fp-utils
Breaks:
 fp-compiler-3.0.4 (<= 3.0.4+dfsg-11),
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fp-compiler-3.0.4 (<= 3.0.4+dfsg-11),
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - utilities
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains some handy utilities for use with the Free Pascal
 Compiler:
  * data2inc   convert binary/text data to include files;
  * fpcmake    create Makefile from Makefile.fpc;
  * h2pas      convert .h files to Pascal units;
  * plex/pyacc Pascal Lex and Yacc implementations;
  * ppdep      create a dependency file for use with Makefiles;
  * ppudump    dump the information stored in a .ppu (unit) file;
  * ppufiles   show needed files for units;
  * ppumove    place multiple units in a shared library;
  * ptop       beautify source.

Package: fp-docs-3.0.4
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 fp-docs
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - documentation
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package provides documentation for the Free Pascal Compiler in HTML
 format.

Package: fp-units-rtl-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-compiler-3.0.4 (= ${binary:Version})
Provides:
 fp-units-rtl,
 fpc-abi-3.0.4
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - runtime libraries
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the RunTime Libraries for the Free Pascal Compiler.

Package: fp-units-base-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 uuid-dev
Provides:
 fp-units-base
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - base units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains Free Pascal units for common libraries (some of which
 are also required by the Free Component Library): NCurses, X11 (Xlib,
 Xutil), and ZLib.

Package: fp-units-fcl-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 fp-units-base-3.0.4 (= ${binary:Version}),
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-fcl
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - Free Component Library
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the Free Component Library for the Free Pascal Compiler.

Package: fp-units-fv-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-fv
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - Free Vision units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the Free Vision units for the Free Pascal Compiler
 (which provide a framework for developing text user interfaces).

Package: fp-units-gtk2-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 fp-units-fcl-3.0.4 (= ${binary:Version}),
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 libgtk2.0-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-gtk2
Breaks:
 fpc (<= 3.0.4+dfsg-0),
Replaces:
 fpc (<= 3.0.4+dfsg-0),
Description: Free Pascal - GTK+ 2.x units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains Free Pascal units and examples to create
 programs with GTK+ 2.x.

Package: fp-units-db-3.0.4
Architecture: any
Multi-Arch: same
Depends:
 fp-units-rtl-3.0.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 firebird-dev,
 freetds-dev,
 libgdbm-dev,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Free Pascal

DEB_PACKAGE_NAME = fpc
export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use pdf/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter l2h/4ht/hevea or html for (default)
CONVERTER=hevea
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}
endif
# Include standard dpkg-buildpackage variables
include /usr/share/dpkg/architecture.mk
# Undefine FPC if it was set
unexport FPC
# Build new compiler name
CPU_SOURCE=${DEB_BUILD_ARCH_CPU}
CPU_TARGET=${DEB_HOST_ARCH_CPU}
# Take care that Debian uses amd64 while FPC perfers x86_64 instead
CPU_SOURCE := $(subst amd64,x86_64,${CPU_SOURCE})
CPU_TARGET := $(subst amd64,x86_64,${CPU_TARGET})
# Take care that Debian uses arm64 while FPC perfers aarch64 instead
CPU_SOURCE := $(subst arm64,aarch64,${CPU_SOURCE})
CPU_TARGET := $(subst arm64,aarch64,${CPU_TARGET})
# Take care that debian uses ppc64 while FPC prefers powerpc64 instead
CPU_SOURCE := $(subst ppc64,powerpc64,${CPU_SOURCE})
CPU_TARGET := $(subst ppc64,powerpc64,${CPU_TARGET})
# Shuld get rid of this one day, as it is done automatically  by FPC make files
ifeq ($(CPU_TARGET),m68k)
PPSUF=68k
endif
ifeq ($(CPU_TARGET),i386)
PPSUF=386
endif
ifeq ($(CPU_TARGET),x86_64)
PPSUF=x64
endif
ifeq ($(CPU_TARGET),powerpc)
PPSUF=ppc
endif
ifeq ($(CPU_TARGET),powerpc64)
PPSUF=ppc64
endif
ifeq ($(CPU_TARGET),alpha)
PPSUF=axp
endif
ifeq ($(CPU_TARGET),arm)
PPSUF=arm
endif
ifeq ($(CPU_TARGET),aarch64)
PPSUF=a64
endif
ifeq ($(CPU_TARGET),sparc)
PPSUF=sparc
endif
ifeq ($(CPU_TARGET),mips)
PPSUF=mips
endif
ifeq ($(CPU_TARGET),mipsel)
PPSUF=mipsel
endif

ifneq ($(CPU_SOURCE),$(CPU_TARGET))
PPPRE=ppcross
else
PPPRE=ppc
endif

PPNEW=$(PPPRE)$(PPSUF)
# Take care that Debian uses kfreebsd while FPC prefers freebsd
OS_TARGET=$(subst kfreebsd,freebsd,${DEB_HOST_ARCH_OS})
# FPC uses FPCTARGET to identify the target for which the binaries are
# produced. This is generally a couple of target CPU and target OS names
# separated by a dash.
FPCTARGET=$(CPU_TARGET)-$(OS_TARGET)
# Get version information from changelog file
DEB_VERSION:=$(shell dpkg-parsechangelog --show-field Version)
DEB_DATE:=$(shell date --utc --date="`dpkg-parsechangelog --show-field Date`" +%Y/%m/%d)
DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
export DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
export PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
endif
# Get directories
INSTALL_DIR=${CURDIR}/debian/tmp
BIN_DIR=${INSTALL_DIR}/usr/bin
# Debian policy is to install libraries that are multi-arch coinstallable in
# /usr/lib/${DEB_HOST_MULTIARCH}
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
DOC_DIR=${INSTALL_DIR}/usr/share/doc
SRC_DIR=${INSTALL_DIR}/usr/share/fpcsrc/${DEB_UPSTREAM_MAIN_VERSION}
EXAMPLE_TEMP=${INSTALL_DIR}/usr/share/doc/fpc-${DEB_UPSTREAM_MAIN_VERSION}
STY_DIR=${INSTALL_DIR}/usr/share/texmf/tex/latex/fpc-${DEB_UPSTREAM_MAIN_VERSION}
# Override standard GNUE make variables
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
ifndef MV
MV=mv
endif
RM:=rm -rf
# Build fpcmake from sources if none is specified.
ifndef FPCMAKE
# Upstream wants that one uses latest FPC make utility to produce make files
# from FPC make files. This is required because, especially in old days, FPC
# make utility used to evolve so that old tool versions were not able to
# process new FPC make files. So it is always safe to start first by building
# this tool from sources and then use it to build make files to build compiler,
# RTL and packages.
FPCMAKE=fpcsrc/utils/fpcm/bin/${FPCTARGET}/fpcmake
endif
# Undefine FPCDIR if it was set
unexport FPCDIR
NEWPP=$(CURDIR)/fpcsrc/compiler/$(PPNEW)
NEWFPDOC=$(CURDIR)/fpcsrc/utils/fpdoc/fpdoc
# Set default compilation options
DEB_BUILD_FPC_OPT=debian/deb-build-fpc.cfg
DEB_HOST_FPC_OPT=debian/deb-host-fpc.cfg
BUILDOPTS=PP=$(NEWPP) OPT='@${CURDIR}/${DEB_HOST_FPC_OPT}'
ifdef CROSSOPT
BUILDOPTS+= CROSSOPT=${CROSSOPT}
endif
INSTALLOPTS=INSTALL_PREFIX=$(INSTALL_DIR)/usr PP=$(NEWPP)

export GDBLIBDIR=/usr/lib

ifeq ($(CPU_TARGET),arm)
  # Disable optimization for the first runs as there may be bugs associated
  # with that, preventing proper building new versions (cf bug 800811)
  #
  # Unsure if the -d option is still needed, this code was originally used to
  # bootstrap other arm flavors
  CYCLEOPTS:=OPT='@${CURDIR}/${DEB_HOST_FPC_OPT} -dFPC_$(DEB_HOST_ARCH)' OPTLEVEL1=-O-
else
  CYCLEOPTS:=OPT='@${CURDIR}/${DEB_HOST_FPC_OPT}'
endif

# Set default compilation options
FPMAKE_BUILDOPTS=FPMAKE_SKIP_CONFIG='-n @${CURDIR}/${DEB_BUILD_FPC_OPT}'

LDFLAGS=$(strip $(shell DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) \
	dpkg-buildflags --get LDFLAGS | \
	sed -e 's/-Wl,//g' -e 's/,/ /g' -e 's1-specs=/usr/share/dpkg/.*\.specs11'))

# Until we switch to shorthand dh, we need to set this ourselves for
# reproducible builds
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

#export DH_VERBOSE=1

###################
# Clean
#

# The default clean target is very heavy for an already clean tree because it
# regenerates all the Makefiles from Makefile.fpc files to be able to call all
# the upstream distclean targets. Therefor the clean target is split into
# multiple components and you can fool the makefiles target when ZERO generated
# Makefiles are found by setting the variable MAY_FOOL_CLEAN to anything but
# the empty string. This is propably a reasonable trade-off under all
# circumstances, but to prevent anything bad from happening during official
# builds, it is not the default.
clean: check-makefiles clean-all-but-makefiles clean-makefiles
	# Make sure the debconf translations are always up-to-date
	debconf-updatepo
	# Make sure the list with timestamps is up-to-date
	[ ! $$(which fp-fix-timestamps) ] || fp-fix-timestamps update
	dh_clean

# See comment above clean target. Fool make-file when approriate
check-makefiles:
ifdef MAY_FOOL_CLEAN
	for fpcfile in `find . -name Makefile.fpc` ; do \
		if [ -f `dirname $$fpcfile`/Makefile ] ; then \
			GOINGTOFOOLCLEAN=false ; \
		fi ; \
	done ; \
	if [ "$$GOINGTOFOOLCLEAN" != false ] ; then \
		echo Beware of empty Makefiles: we are going to fool the makefiles target now ; \
		for fpcfile in `find . -name Makefile.fpc` ; do \
			touch `dirname $$fpcfile`/Makefile ; \
		done ; \
		touch makefiles-stamp ; \
	fi
endif

# In essence, this is the real clean target, except it doesn't remove the
# generated Makefiles. It should do ALL the other cleaning though.
clean-all-but-makefiles: makefiles
	dh_testdir

	# Remove the gnome1, gtk1, fpgtk and imlib packages
	# as they depend on libraries long go removed from Debian.
	rm -rf fpcsrc/packages/gnome1
	rm -rf fpcsrc/packages/gtk1
	rm -rf fpcsrc/packages/imlib
	rm -rf fpcsrc/packages/fpgtk
	# The following packages depend on (at least) fpgtk and were
	# not build in Debian anyways. The makefiles target fails to run
	# if we remove the above, but not these because fpcmake checks
	# for all Makefile.fpc files and notices that the dependency is
	# not fullfilled.
	rm -rf fpcsrc/utils/fpdoc/fpde
	rm -rf fpcsrc/utils/fpmc

	# Call upstream clean targets
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc compiler_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc rtl_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc packages_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc ide_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc utils_distclean
	[ ! -s fpcdocs/Makefile ] || $(MAKE) -C fpcdocs clean
	# Just in case they forgot something
	find -regex '.*\.\(a\|or?\|so\.*\|ppu\|compiled\)' -delete
	# Not all empty directories are cleaned up properly by the upstream
	find . -type d -empty -delete

	# Revert hardcoded dates
